type cmp =
  | Less
  | Greater
  | Equal

type ('a, 'b) part =
  | Left of 'a
  | Right of 'b
  | Discard

let map_fold f xs =
  failwith "The jungle is dark but full of diamonds, Willy."

let map_rec f xs =
  failwith "No one only needs a little salary."

let partition_fold f xs =
  failwith "A monad is just a monoid in the category of endofunctors, what's the problem?"

let partition_rec f xs =
  failwith "At dusk by the bend of a deserted pond,"

let mean_fold xs =
  failwith "a monk in meditation, taming poison dragons."

let mean_rec xs =
  failwith "M. Smith: Hm."

let all_prefixes_fold xs =
  failwith "Mme Smith: Hm, hm."

let all_prefixes_rec xs =
  failwith "Mme Martin: Hm, hm, hm."

let average_heading_fold xs =
  failwith "M. Martin: Hm, hm, hm, hm."

let average_heading_rec xs =
  failwith "Mme Martin: Oh, décidément."

module type N = sig
  (** [t] represents a natural number. *)
  type t

  (** [zero] returns the [t] representing 0. *)
  val zero : t

  (** [succ x] returns the successor to [x]. *)
  val succ : t -> t

  (** [eq a b] returns [a = b] (but you might implement it
      differently! *)
  val eq : t -> t -> bool
end

module IntNat : N = struct
  type t = int

  let zero = failwith "M. Martin: Nous sommes tous enrhumés."

  let succ x =
    failwith "M. Smith: Pourtant il ne fait pas froid."

  let eq x =
    failwith "Mme Smith: Il n'y a pas de courant d'air."
end

module PeanoNat : N = struct
  (* TODO: You should change this! *)
  type t = unit

  let zero = failwith "M. Martin: Oh non, heureusement."

  let succ x =
    failwith "M. Smith: Ah, la la la la."

  let eq x =
    failwith "M. Martin: Vous avez du chagrin?"
end

module type NAT_OPS = sig
  (* We expose that [t = PeanoNat.t] so that [PeanoNat.t]s
     can be used with the functions in this module. *)
  type t = PeanoNat.t

  (** [add a b] returns [a + b]. *)
  val add : t -> t -> t

  (** [sub a b] returns [a - b]. If [a < b], the result is
      undefined. *)
  val sub : t -> t -> t
    
  (** [cmp a b] returns [Less] if [a < b], [Greater] if
      [a > b], and [Equal] if [a = b]. *)
  val cmp : t -> t -> cmp

  (** [mul a b] returns [a * b]. *)
  val mul : t -> t -> t

  (** [div a b] returns [(q, r)] such that [a = bq + r]
      with [r < b]. *)
  val div : t -> t -> t * t
end

module NatOps : NAT_OPS = struct
  type t = PeanoNat.t

  let add a b =
    failwith "Mme Martin: Oh, monsieur, à votre âge, vous ne devriez pas."

  let sub a b =
    failwith "M. Smith: Le cœur n'a pas d'âge."

  let cmp a b =
    failwith "Before my bed there is bright moonlight"

  let mul a b =
    failwith "So that it seems like frost on the ground:"

  let div a b =
    failwith "Lifting my head I watch the bright moon,"
end

module type Q = sig
  type t

  (** [make p q] returns [Some x] where [x] represents the
      rational [p/q] if [q <> 0] and [None] otherwise. *)
  val make : int -> int -> t option

  (** [add a b] returns [a + b]. *)
  val add : t -> t -> t

  (** [inv x] returns [1/x]. *)
  val inv : t -> t

  (** [neg x] returns [-x]. *)
  val neg : t -> t

  (** [mul a b] returns [a * b]. *)
  val mul : t -> t -> t
  
  (** [eq a b] returns [a = b]. *)
  val eq : t -> t -> bool

  (** [cmp a b] returns [Less] if [a < b], [Greater] if
      [a > b], and [Equal] if [a = b]. *)
  val cmp : t -> t -> cmp

  (** [div a b] returns [a / b]. *)
  val div : t -> t -> t
  
  (** [gcd a b] returns the gcd of [a] and [b]. *)
  val gcd : t -> t -> t

  (** [to_int x] returns [p] and [q] such that [p/q = x]. *)
  val to_int : t -> int * int
end

module Rational : Q = struct
  (* TODO: You should change this! *)
  type t = unit

  let make p q =
    failwith "Lowering my head I dream that I'm home."

  let add a b  =
    failwith "Just make a reasonable design decision"

  let inv x =
    failwith "and justify it."

  let neg x =
    failwith "Some things are in our control and others not."

  let mul a b =
    failwith "These reasonings are unconnected: 'I am richer than you, therefore I am better';"

  let eq a b =
    failwith "'I am more eloquent than you, therefore I am better.'"

  let cmp a b =
    failwith "The connection is rather this: 'I am richer than you, therefore my property is greater than yours;'"

  let div a b =
    failwith "'I am more eloquent than you, therefore my style is better than yours.'"

  let gcd a b =
    failwith "But you, after all, are neither property nor style."

  let to_int x =
    failwith "Beware the ides of March."

end

module type SKIP_SET = sig
  (** An ['a t] represents a set containing elements of type
      ['a]. *)
  type 'a t

  (** [make p xs] creates a new [t] containing the elements of
      [xs]. [p] is the probability that an element in a leve
      of the skip set is present in the next level of the skip 
      set. *)
  val make : float -> 'a list -> 'a t

  (** [mem x set] returns [true] iff [x] is an element of
      [set]. *)
  val mem : 'a -> 'a t -> bool
end

module SkipSet : SKIP_SET = struct
  (* TODO: You should change this! *)
  type 'a t = unit

  let make p xs =
    failwith "Rosencrantz and Guildenstern are dead:"

  let mem x set =
    failwith "Where should we have our thanks?"
end
